﻿using iFileProxy.Models;
using iFileProxy.Services;

using Microsoft.AspNetCore.Mvc;

namespace iFileProxy.Controllers
{
    public class iProxyController : ControllerBase
    {
        static readonly TaskManager taskManager = new ();

        [HttpPost]
        [Route("/AddOfflineTask")]
        public ActionResult<CommonRsp> AddOfflineTask()
        {
            return taskManager.AddTask(HttpContext) switch
            {
                TaskAddState.Success => (ActionResult<CommonRsp>)Ok(new CommonRsp() { retcode = (int)TaskAddState.Success, message = "succ" }),
                TaskAddState.Fail => (ActionResult<CommonRsp>)Ok(new CommonRsp() { retcode = (int)TaskAddState.Fail, message = "unkown error!" }),
                TaskAddState.ErrUrlRepeat => (ActionResult<CommonRsp>)Ok(new CommonRsp() { retcode = (int)TaskAddState.ErrUrlRepeat, message = "此url已经在任务队列中,请勿重复提交" }),
                TaskAddState.ErrTaskIdRepeat => (ActionResult<CommonRsp>)Ok(new CommonRsp() { retcode = (int)TaskAddState.ErrTaskIdRepeat, message = "TaskIdRepeat!!!" }),
                TaskAddState.ErrUrlInvalid => (ActionResult<CommonRsp>)Ok(new CommonRsp() { retcode = (int)TaskAddState.ErrUrlInvalid, message = "非法Url" }),
                TaskAddState.ErrDbFail => (ActionResult<CommonRsp>)Ok(new CommonRsp() { retcode = (int)TaskAddState.ErrDbFail, message = "数据库数据提交失败!" }),
                _ => (ActionResult<CommonRsp>)Ok(new CommonRsp() { retcode = (int)TaskAddState.Success, message = "succ default" }),
            };
        }

        [HttpPost]
        [HttpGet]
        [Route("/GetMyTasks")]
        public ActionResult<CommonRsp> GetMyTasks()
        {
            return Ok(new CommonRsp() { retcode = 0, message = "succ" });
        }
    }
}
